#include <stdio.h>
#include "empthread.h"

#ifdef _EMPTH_LWP

int
empth_init (ctx, flags)
     char **ctx;
     int flags;
{
    lwpInitSystem(7, ctx, flags);
    return 0;
}


empth_t *
empth_create (prio, entry, size, flags, name, desc, ud)
     int prio;
     void (*entry)();
     int size;
     int flags;
     char *name;
     char *desc;
     void *ud;
{
    /* inherit flags */
    if(!flags)
	flags = LwpCurrent->flags;
    return lwpCreate(prio, entry, size, flags, name, desc, 0, 0, ud);
}

void
empth_setctx(ctx)
     void *ctx;
{
    /* lwp does it automatically */
    return;
}

empth_t *
empth_self()
{
    return LwpCurrent;
}

void empth_exit ()
{
    lwpExit();
}
	
void empth_yield ()
{
    /* a hack! */
    lwpReschedule();
}

void empth_terminate(a)
     empth_t *a;
{
    lwpTerminate(a);
}

void empth_select(fd, flags)
     int fd;
     int flags;
{
    lwpSleepFd(fd, flags);
}

void empth_wakeup(a)
     empth_t *a;
{
    lwpWakeupFd(a);
}

void empth_sleep(until)
     long int until;
{
    lwpSleepUntil(until);
}


empth_sem_t *empth_sem_create(name, cnt)
     char *name;
     int cnt;
{
    return lwpCreateSem(name, cnt);
}

void empth_sem_signal(sm)
     empth_sem_t *sm;
{
    lwpSignal(sm);
}

void empth_sem_wait (sm)
     empth_sem_t *sm;
{
    lwpWait(sm);
}

emp_sig_t empth_alarm(sig)
     int sig;
{
    /* no way we can be here while using LWP threads */
    panic(sig);
}
#endif

